# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from stark_ros_msgs/NDArray.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class NDArray(genpy.Message):
  _md5sum = "be035f172515bdedd33f577f9d07cb0b"
  _type = "stark_ros_msgs/NDArray"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Packed, single dtype Numpy array

# dtype from enumeration in DTypes.msg
uint8 dtype

# Array shape
uint64[] shape

# Row(C)/Column(Fortran) major (off by default)
# https://en.wikipedia.org/wiki/Row-_and_column-major_order
bool is_column_major

# Is the data blob bigendian? (off by default)
bool is_bigendian

# Array data
uint8[] data
"""
  __slots__ = ['dtype','shape','is_column_major','is_bigendian','data']
  _slot_types = ['uint8','uint64[]','bool','bool','uint8[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       dtype,shape,is_column_major,is_bigendian,data

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NDArray, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.dtype is None:
        self.dtype = 0
      if self.shape is None:
        self.shape = []
      if self.is_column_major is None:
        self.is_column_major = False
      if self.is_bigendian is None:
        self.is_bigendian = False
      if self.data is None:
        self.data = b''
    else:
      self.dtype = 0
      self.shape = []
      self.is_column_major = False
      self.is_bigendian = False
      self.data = b''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.dtype
      buff.write(_get_struct_B().pack(_x))
      length = len(self.shape)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(struct.Struct(pattern).pack(*self.shape))
      _x = self
      buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
      _x = self.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.dtype,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.shape = s.unpack(str[start:end])
      _x = self
      start = end
      end += 2
      (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
      self.is_column_major = bool(self.is_column_major)
      self.is_bigendian = bool(self.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.dtype
      buff.write(_get_struct_B().pack(_x))
      length = len(self.shape)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(self.shape.tostring())
      _x = self
      buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
      _x = self.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.dtype,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.shape = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
      _x = self
      start = end
      end += 2
      (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
      self.is_column_major = bool(self.is_column_major)
      self.is_bigendian = bool(self.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
